#include<stdio.h>
#include <stdlib.h>
#include<iostream.h>
#include<strstream.h>
#include<string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <ctype.h>
#include<math.h>

//#define HOST_NAME "icfp1.cse.ogi.edu"
#define __DEBUG__

//#define MAXDATASIZE 100000
#define MAXDATASIZE 2000000
#define MAX_ROBOTS 1000000


#define MAX_WIDTH 102
#define MAX_HEIGHT 102
#define MAX_PACKAGES 1000

#define MAX_QU 1000000
//#define MAX_QU 10000
#define MAXNUM 10000

#define OBJBLANK 0x0
#define OBJWATER 0x1
#define OBJPACKAGE 0x2
#define OBJWALL 0x4
#define OBJROBOT 0x8
#define OBJDESTINATION 0x10


char *host;
int port;

class Position {
public:
  int x,y;

  Position(){}

  Position(int a,int b) { x=a; y=b; }
  
  //  Position(Position &pos) { x=pos.x; y=pos.y; }

  int operator != (Position pos) {
    if(this->x!=pos.x || this->y!=pos.y)
      return 1;
    else
      return 0;
  }

  int operator == (Position pos) {
    if(this->x==pos.x && this->y==pos.y)
      return 1;
    return 0;
  }

  Position operator + (Position& pos) {
    Position temp;
    temp.x = this->x + pos.x;
    temp.y = this->y + pos.y;
    return temp;
  }

  //be careful, this return manhattan distance
  int operator - (Position& pos) {
    int dx = abs(pos.x - x);
    int dy = abs(pos.y-y);
    return (dx + dy);
  }
};

class Cell {
public:
  int content;
  //0x0   blank
  //0x1   water
  //0x2   package
  //0x4   wall
  //0x8   robot
  //0x16  destination

  int potential;
  Position previous;
  int distance;

  Cell() { previous.x = MAX_WIDTH+3; previous.y = MAX_HEIGHT+3; potential = 0; distance=MAXNUM; }
};


class Package {
public:
  int id;
  int weight;
  Position destination;
  Position currentlocation;
  int ownerrobotid;

  Package() {
    weight=-1;
    ownerrobotid=-1;
  }
};

class Robot {
public:
  int id;
  Position currentlocation;
};

class Target {
public:
  Position location;
  int isdestination;
  int ispackage;
  Target() { isdestination = 0; ispackage=0;}
};
  

class Board {
public:
  int width, height;

  Cell cell[MAX_WIDTH][MAX_HEIGHT];
   
  Package package[MAX_PACKAGES]; //global list  of all known packages
  int totalknownpackages;

  //  Position target[1000]; //
  //int targetcount;


  Board(){ totalknownpackages=0;}

  void printBoard(Position p) {
    printf("inside printboard %d %d \n",width,height);
    const char str[] = ".~@ #   r r     d";
    for(int i=0 ; i<height+2; i++) {

      printf("\n  ");
      for(int j=0; j<width+2; j++)
	if(p.x == j && p.y == i)
	  printf(" I");
	else
	  printf(" %c", str[cell[j][i].content]);
    }

  }

  void initializeBoard(int w, int h, char bd[MAX_WIDTH][MAX_HEIGHT]){
    width = w;
    height = h;
    for(int i=0; i<=width+1; i++)
      for(int j=0; j<=height+1; j++) {
	//	cell[i][j].content=0;
	
	if(i== 0 || j==0 || i==width+1 || j==height+1) {
	  cell[i][j].content=OBJWALL;
	}
	else {
	  switch(bd[i][j]) {
	  case '.': cell[i][j].content=OBJBLANK;break;
	  case '~': cell[i][j].content=OBJWATER;break;
	  case '#': cell[i][j].content=OBJWALL;break;
	  case '@': cell[i][j].content=OBJPACKAGE;break;
	  default: cerr<<" cell type error"; 
	  }
	}
      }
  }


  void setCellContent(int x,int y,char c) {
    switch(c) {
    case '.': cell[x][y].content=OBJBLANK; break;
    case '~': cell[x][y].content=OBJWATER; break;
    case '#': cell[x][y].content=OBJWALL; break;
    case '@': cell[x][y].content|=OBJPACKAGE; break;
    case 'r': cell[x][y].content|=OBJROBOT; break;
    default: cerr<<" cell type error"; 
    }
    printf("modified cell %d %d\n", x,y);
  }

  int getPackageIndex(int packid) {
    int index=-1;
    for(int i=0; i<totalknownpackages; i++) {
      if(package[i].id==packid) {
	index=i;
	break;
      }
    }
    return index;
  }

  void executeMove(Position current, char direction) {
    Position new1 = current;
    switch(direction){
    case 'N': new1.y--; break;
    case 'S': new1.y++; break;
    case 'E': new1.x++; break;
    case 'W': new1.x--; break;
    }
    cell[current.x][current.y].content &= ~OBJROBOT;
    cell[new1.x][new1.y].content |= OBJROBOT;
  }

  void executePick(int robotid, int packid, Position pos,int& mycurrentcapacity,int myid,Position mypos) {
    int pindex = getPackageIndex(packid);
    package[pindex].ownerrobotid =robotid;
    if(pindex==-1){
      if(totalknownpackages<MAX_PACKAGES)
	package[totalknownpackages++].id = packid;
    }
    else {
      if(robotid == myid) {
	cell[package[pindex].destination.x][package[pindex].destination.y].content|=OBJDESTINATION;
	mycurrentcapacity-=package[pindex].weight;
      }
    }
    
    int morepackages=0;
    for(int i=0; i<totalknownpackages; i++) {
      if(package[i].currentlocation==pos && package[i].ownerrobotid==-1) {
	morepackages=1;
	break;
      }
    }
    
    if(!morepackages) {
      cell[pos.x][pos.y].content &= ~OBJPACKAGE;
    }      
  }

  void executeDrop(int robotid, int packid, Position pos, int& mycurrentcapacity,int myid) {
  }
};

class Game {


  Board board;
  Robot robot[MAX_ROBOTS];
  int robotcount;


  //  char buffer[MAXDATASIZE];
  int sock;
  int myid, myindex, mymaxcapacity, mycurrentcapacity, mycurrentmoney;

  int capacityover;

  Position attemptedmove;

  float threshold;
  char buff[MAXDATASIZE];

  int pathstored;
  int continuebfs; //boolean to decide whether to  continue bfs
  Position cdest;
public:  
  Game(){
    initSock();
    robotcount = 0;
    capacityover = 0;
    threshold = 0.4;
    pathstored = 0;
    continuebfs = 0;
    //    targetcount = 0;
  }

  //tcp/ip interface
  int sendCommand()
    {
      int l = strlen(buff);
      
      printf("Sending : \n");
      puts(buff);
      
      return(write(sock, buff, l));
    }
  
  int receiveCommand()
    {
      int n;
      //printf(" In receive\n");
      n = read(sock, buff, MAXDATASIZE-1);
      buff[n] = '\0';
      if(n<=0)
	exit(EXIT_SUCCESS);

      printf("Received : \n");
      puts(buff);
      return 0;
    }

  void initializeGame();  
 
  int initSock()
    {
      struct sockaddr_in addr;
      struct hostent *he;
      
      sock = socket(AF_INET, SOCK_STREAM, 0);
      
      he = gethostbyname(host);
      addr.sin_addr = *(struct in_addr *)he->h_addr ;
      addr.sin_port = htons(port);
      addr.sin_family = AF_INET;
      memset(&(addr.sin_zero), 0, 8);
      
      if(connect(sock, (struct sockaddr *) &addr, sizeof(struct sockaddr)) == -1)
	{
	  perror("connect");
	  return -1;
	}

      return 0;
    }
   
  
  void start()
    {
      int u=0;
      printf("start %d\n", u++);
      sendEnterRequest();
      printf("start %d\n", u++);
      receiveCommand();
      printf("start %d\n", u++);
      initializeGame();
      //printf("start %d\n", u++);
      //      configureMyRobot();
      // getAllRobotPositions();

      getPackagesForCurrentLocation();

      board.printBoard(robot[myindex].currentlocation);
      while(1)
	{
	  
	  //	  if(random()&1)
	  //  sendMove('N');
	  //else
	  //  sendMove('S');
	  
	  nextMove();
	  getCurrentCommandsAndPackages();
	  board.printBoard(robot[myindex].currentlocation);
	}
    }

  int isInsideBoard(Position pos) {
    if(pos.x >=1 && pos.x <= board.width && pos.y >=1 && pos.y <=board.height)
      return 1;
    else
      return 0;
  }
  char findMoveDirection(Position src, Position dest) {
    
    if(src.x != dest.x){
      if(src.x > dest.x)
	return 'W';
      else
	return 'E';
    }
    else {
      if(src.y > dest.y)
	return 'N';
      else
	return 'S';
    }
  }

  void nextMove() {
 
    int queuemin=0, queuemax=1;
    
    Position qu[MAX_QU];
    
    int i,j;
    
    qu[0] = robot[myindex].currentlocation;
    
    for(i=0;i<board.width;++i)
      for(j=0;j<board.height;++j)
	{
	  board.cell[i][j].distance = MAXNUM;
	  board.cell[i][j].previous = Position(-1,-1);
	}

    board.cell[robot[myindex].currentlocation.x][robot[myindex].currentlocation.y].distance=0;

    Position moves[4];
    moves[0]= Position(1,0);
    moves[1]= Position(-1,0);
    moves[2]= Position(0,1);
    moves[3]= Position(0,-1);
        
    while(!(((board.cell[qu[queuemin].x][qu[queuemin].y].content&OBJPACKAGE) && ((float)mycurrentcapacity/mymaxcapacity > threshold)) || board.cell[qu[queuemin].x][qu[queuemin].y].content&OBJDESTINATION) && queuemin!=queuemax) {
      
      //printf("enter\n");


      for(i=0; i<4; i++) {

	if(Position(qu[queuemin].x + moves[i].x,qu[queuemin].y + moves[i].y)!=board.cell[qu[queuemin].x][qu[queuemin].y].previous) {
	  if((qu[queuemin].x + moves[i].x >= 1)&& (qu[queuemin].x + moves[i].x <= board.width) && (qu[queuemin].y + moves[i].y >=1) && (qu[queuemin].y + moves[i].y <= board.height)) {
	    if(!(board.cell[qu[queuemin].x + moves[i].x][qu[queuemin].y + moves[i].y].content&OBJWALL || board.cell[qu[queuemin].x + moves[i].x][qu[queuemin].y + moves[i].y].content&OBJWATER)) {
	      if(queuemax != queuemin){
		
		int currentdistance = board.cell[qu[queuemin].x + moves[i].x][qu[queuemin].y + moves[i].y].distance;
		int newdistance = board.cell[qu[queuemin].x][qu[queuemin].y].distance + 1;
		
		// Our robot is shy - we increase the distance proportinately to the distance of the square the othre robot is on
		// from our square, the constant of proportionaty is the 
		// cell potential ..
		/*
		if( (board.cell[qu[queuemin].x+moves[i].x][qu[queuemin].y+moves[i].y].content&OBJROBOT)  
		    && (board.cell[robot[myindex].currentlocation.x][robot[myindex].currentlocation.y]!=
			board.cell[qu[queuemin].x+moves[i].x][qu[queuemin].y+moves[i].y].content)
		    ){
		  // TO DO 
		   currentdistance += board.cell[qu[queuemin].x+moves[i].x][qu[queuemin].y+moves[i].y].potential/(n*n);
		  
		}
		*/
		
		if(currentdistance>newdistance) {
		  board.cell[qu[queuemin].x + moves[i].x][qu[queuemin].y + moves[i].y].distance = newdistance;
		  board.cell[qu[queuemin].x + moves[i].x][qu[queuemin].y + moves[i].y].previous = qu[queuemin];
		  qu[(queuemax + 1) % MAX_QU].x = qu[queuemin].x + moves[i].x;
		  qu[(queuemax + 1) % MAX_QU].y = qu[queuemin].y + moves[i].y;
		  
		  queuemax = (queuemax+1)%MAX_QU;
		}
	      }
	    }
	  }
	}
      }
      queuemin = (queuemin + 1) % MAX_QU;
    }   
    
    // TO DO
    // what if there r no more packages 
    

    // Where have we reached ?
    // shud we pick up a package on the current square ?
    // or shud we move to another square ?
    


    int temp=mycurrentcapacity;
    int pa[1024], pacount=0;
    int pb[1024], pbcount=0;
    
    Position currentlocation = robot[myindex].currentlocation;

    for(i=0;i<board.totalknownpackages;++i)
      {
	if( board.package[i].currentlocation == currentlocation)
	  {	  
	    if(temp > board.package[i].weight && board.package[i].ownerrobotid==-1)
	      {
		pa[pacount++] = board.package[i].id;
		temp -= board.package[i].weight;
	      }
	  }

	if( board.package[i].ownerrobotid == myid && board.package[i].destination==currentlocation)
	  {
	    cout << "dropping " << board.package[i].id << endl; 
	    pb[pbcount++] = board.package[i].id;
	    temp += board.package[i].weight;
	  }
      }
		
    if(pacount)
      sendPick(pa, pacount);
    
    if(pbcount)
      sendDrop(pb, pbcount);



    //shud we drop a package we have 
  

    //    printf("robot position x=%d y=%d \n", robot[myindex].currentlocation


    if(!(pacount || pbcount))
      {
	Position current = qu[queuemin]; 
	if(current!=robot[myindex].currentlocation && queuemax!=queuemin) {
	  while(board.cell[current.x][current.y].previous!=robot[myindex].currentlocation){
	    printf("backtracing to x=%d y=%d \n",current.x,current.y);
	    if(isInsideBoard(current))
	       current = board.cell[current.x][current.y].previous;
	    else
	      break;
	  }


	  printf("moving to x=%d y=%d \n",current.x,current.y);

	  char direction;
	  if(current.x != robot[myindex].currentlocation.x){
	    if(current.x > robot[myindex].currentlocation.x)
	      direction = 'E';
	    else
	      direction = 'W';
	  }
	  else{
	    if(current.y > robot[myindex].currentlocation.y)
	      direction = 'S';
	    else
	      direction = 'N';
	  }
	  
	  sendMove(direction);
	}
	else
	  sendDrop(NULL,0);
	
	
      }
    
    
  }
  
  

  //enter the game
  void sendEnterRequest() {
    sprintf(buff,"Player\n");
    sendCommand();
  }

  void getPackagesForCurrentLocation(){
    receiveCommand();
    istrstream str(buff);
    int id;
    while(str>>id) {
      int x,y,weight;
      str>>x>>y>>weight;
      board.package[board.totalknownpackages].id = id;
      board.package[board.totalknownpackages].currentlocation = robot[myindex].currentlocation;
      board.package[board.totalknownpackages].destination.x = x;
      board.package[board.totalknownpackages].destination.y = board.height - y + 1;
      board.package[board.totalknownpackages++].weight = weight;
    }
  }

  void getCurrentCommandsAndPackages(){
    receiveCommand();
    istrstream str(buff);
    char c;
    int val, val1, id;
    // cout<<"reading char array <" << buff << ">\n";

    while(str>>c && c!='\n') {
      //str>>c;
      cout<<c ; 
      if(c=='#') {
	str>>id;
	str>>c;
      }

      switch(c){
      case 'X': str>>val>>c>>val1; addRobot(id, val,board.height - val1 + 1); board.setCellContent(val,board.height-val1+1,'r'); break;
      case 'P': str>>val; executePick(id,val); break;
      case 'D': str>>val; executeDrop(id,val); break;
      case 'S':
      case 'N':
      case 'E':
      case 'W': executeMove(id,c); break;
      }
    }

    cout<<"end read char array\n";
    //getting packages
    
    char *ptr=buff;
    while(*ptr!='\n') ptr++;
    ptr++;

    istrstream str1(ptr);
    while(str1>>id) {
      int  x,y,weight;
      str1>>x>>y>>weight;
      //printf("Package: id=%d x=%d y=%d weight=%d\n",id,x,y,weight);
      if(board.getPackageIndex(id)==-1) {
	board.package[board.totalknownpackages].id = id;
	board.package[board.totalknownpackages].currentlocation = robot[myindex].currentlocation;;
	
	board.package[board.totalknownpackages].destination.x = x;
	board.package[board.totalknownpackages].destination.y = board.height - y + 1;

	board.package[board.totalknownpackages++].weight = weight;
      }
    }

    for(int i=0;i<board.totalknownpackages;i++) {
      printf("Package: id=%d x=%d y=%d weight=%d owner=%d\n",board.package[i].id,board.package[i].destination.x,board.package[i].destination.y,board.package[i].weight,board.package[i].ownerrobotid);
    }
      
  }

  //execute commands on board
  void executeMove(int robotid, char direction){
    int rindex = getRobotIndex(robotid);

    printf("move robotid %d index %d direction %c\n\n",robotid,rindex,direction);
    
    Position myoldpos = robot[rindex].currentlocation;

    board.executeMove(robot[rindex].currentlocation, direction); 

    printf("Robot at %d %d ", robot[rindex].currentlocation.x,  robot[rindex].currentlocation.y);

    switch(toupper(direction)) {
    case 'N': robot[rindex].currentlocation.y--;break;
    case 'S': robot[rindex].currentlocation.y++;break;
    case 'E': robot[rindex].currentlocation.x++;break;
    case 'W': robot[rindex].currentlocation.x--;break;
    }

    printf("Robot at %d %d\n\n ", robot[rindex].currentlocation.x,  robot[rindex].currentlocation.y);

    if(robotid == myid && pathstored) {
      Position temppos = cdest;


      while(board.cell[temppos.x][temppos.y].previous!=myoldpos  && isInsideBoard(temppos)){
	temppos = board.cell[temppos.x][temppos.y].previous;
      }
       
      if(temppos != robot[myindex].currentlocation) {
	pathstored = 0;
	continuebfs = 0;
      }
    }
  }
      

    void executePick(int robotid, int packid){    
      int rindex = getRobotIndex(robotid);
      board.executePick(robotid, packid, robot[rindex].currentlocation,mycurrentcapacity,myid,robot[myindex].currentlocation);
    }

    void executeDrop(int robotid, int packid){
      int rindex = getRobotIndex(robotid);
      //    board.executeDrop(robotid, packid, robot[rindex].currentlocation, mycurrentcapacity,myid);
      int pindex = board.getPackageIndex(packid);
    

      if(pindex==-1) {
	if(board.totalknownpackages<MAX_PACKAGES) {
	  board.package[board.totalknownpackages].id = packid;
	  board.package[board.totalknownpackages].currentlocation = robot[rindex].currentlocation;
	}

	if(robotid==myid)
	  cerr<<"serious error";
      }
      else { 
	if(board.package[pindex].destination == cdest)
	  pathstored=0;
      }

      //    cout<<"current pos "<<pos.x<<" "<<pos.y<<"\n";
      //    cout<<"destination "<<package[pindex].destination.x<<" "<<package[pindex].destination.y<<"\n";

      if(robot[rindex].currentlocation != board.package[pindex].destination) {
	board.cell[robot[rindex].currentlocation.x][robot[rindex].currentlocation.y].content |=OBJPACKAGE;
	board.package[pindex].ownerrobotid = -1;
	board.package[pindex].currentlocation = robot[rindex].currentlocation;
      }
      else
	board.package[pindex].ownerrobotid = -10;

      Position pos = robot[rindex].currentlocation;

      int i;
      for(i=0; i<board.totalknownpackages; i++) {
	if(board.package[i].id==packid  &&  board.package[i].destination==pos && robotid==myid) {
	  printf("unsetting the destination flag...\n");
	  board.cell[pos.x][pos.y].content &= ~OBJDESTINATION;
	  break;
	}
      }
      if(robotid==myid)
	mycurrentcapacity+=board.package[pindex].weight;
	      
    }

      
    //prepare commands and send them
    void sendMove(char direction, int bid = 1){
      sprintf(buff,"%d Move %c \n", bid, direction);
    
      sendCommand();
    }

    void sendPick(int packid[],int count){
      sprintf(buff,"1 Pick");
      for(int i=0; i<count; i++){
	sprintf(buff+strlen(buff)," %d", packid[i]);
      }
      sprintf(buff+strlen(buff),"\n");
      sendCommand();
    }

    void sendDrop(int packid[],int count){
      sprintf(buff,"1 Drop");
      for(int i=0; i<count; i++){
	sprintf(buff+strlen(buff)," %d", packid[i]);
      }
      sprintf(buff+strlen(buff),"\n");
      sendCommand();
    }    

    //miscellaneous


    int getRobotIndex(int robotid) {
      int index=-1;
      for(int i=0; i<robotcount; i++) {
	if(robot[i].id==robotid) {
	  index=i;
	  break;
	}
      }
      return index;
    }

    void addRobot(int id, int x,int y) {
      int rindex = getRobotIndex(id);
      printf("robotid %d index %d\n",id,rindex);

      if(rindex==-1) {
	printf("added \n");
	robot[robotcount].id = id;
	robot[robotcount].currentlocation.x = x;
	robot[robotcount++].currentlocation.y = y;
      }
  
    }      
  };
  int main(int argc, char *argv[])
    {
      
      if(argc!=3)
	{
	  printf("Usage %s : host-name port\n",argv[0]);
	  printf("   eg: %s icfpcontest.cse.ogi.edu 22001\n",argv[0]);
	  return 0;
	}

      host = strdup(argv[1]);
      port = atoi(argv[2]);
  
      Game *g;
      g = new Game();
      g->start();
    }

  //receive and parse commands
  void Game::initializeGame() {
   
    
    int i,j;
    
    char str[100];
    
    //receiving width and height of the board
    int width,height;
    //    char t[128]="here\n";
    //puts(t);
    //    cout<<"\namit\n\n\n\n\n";
    char *ptr;

    //printf("before receive\n");

    //receiveCommand();

    //printf("after receive \n");
    
    //printf("-------[%s]------",buff);
    i=0;
    ///printf("%c\n",buff[0]);

      //while(buff[i]!='\n') printf("%x -> %d: %c\n",(int )buff+i,i, buff[i++]);
      //printf("\n");
      //printf("%d", strlen(buff));
      //    return;
      sscanf(buff,"%d %d",&width, &height);
      printf("width = %d  height  = %d \n",width, height);
      char bd[MAX_WIDTH][MAX_HEIGHT];

      ptr = buff;
      while( *ptr!='\0' && *ptr!='\n') ++ ptr;
      ++ptr;
      //printf("ptr -> <%s>\n",ptr);

      for(i=1; i<=height; i++) {
	//extract lines to  str;

	j=0;
	while(*ptr!='\n' && *ptr!='\0')
	  str[j++] = *ptr++;
       
	str[j]='\n';
	++ptr;
	printf("%s\n",str);
	for(j=1; j<=width; j++)
	  bd[j][height-i+1]=str[j-1];
      }
    
      //    printf("print bd");
      //for(i=1; i<=height; i++)
      // {
      //	printf("\n");
      //	for(j=1; j<=width; j++)
      //	  printf(" %c",bd[j][i]);
      //}
      //printf("...end printing bd");

      board.initializeBoard(width, height, bd);
    
    
      //receiveCommand(buffer);
      int id, capacity, money;
      sscanf(ptr, "%d %d %d", &id, &capacity, &money);
      myid = id;
      mymaxcapacity = capacity;
      mycurrentcapacity = capacity;
      mycurrentmoney = money;

      while(*ptr!='\n' && *ptr!='\0')
	str[j++] = *ptr++;
       
      str[j]='\n';
      ++ptr;

      istrstream str1(ptr);
      char  c; 
      int x,y;
      while(str1>>c) {
	//str1>>c; //read #
	str1>>id;
	str1>>c>>x; //read X and its value
	str1>>c>>y; //read Y and its value

	if(id==myid){
	  myindex = robotcount;
	  printf("setting myindex\n");
	}
      
	board.setCellContent(x,board.height - y +1, 'r');
	addRobot(id,x,board.height - y + 1);
      }
  }
